#include <jni.h>;
#include "marFunction.h"
#include "MarianaInterface.h"



JNIEXPORT jstring JNICALL Java_MarianaInterface_build (JNIEnv *env, jobject obj, 
		jstring trainStr, jstring valStr, jstring tstStr) 
{
	jboolean iscopy;
	char * trn;
	char * val;
	char * tst;
	
	trn = (char*)env->GetStringUTFChars(trainStr, &iscopy);
	val = (char*)env->GetStringUTFChars(valStr, &iscopy);
	tst = (char*)env->GetStringUTFChars(tstStr, &iscopy);
	
	int argc = 3;
	char * argv[] = { "train1", "val1", "tst1"};
	
	const char* res = marFunction(trn, val, tst, argc, argv);
	jstring rtrn = env->NewStringUTF(res);
	
//	(*env)->ReleaseStringChars(env, trainStr, trn);
    env->ReleaseStringUTFChars(trainStr, trn);
	env->ReleaseStringUTFChars(valStr, val);
	env->ReleaseStringUTFChars(tstStr, tst);
	
	return (rtrn);
}

JNIEXPORT jstring JNICALL Java_MarianaInterface_predict (JNIEnv *env, jobject obj, 
		jstring modelStr, jstring inputStr) 
{
	jboolean iscopy;
	char * model;
	char * input;
	
	model = (char*)env->GetStringUTFChars(modelStr, &iscopy);
	input = (char*)env->GetStringUTFChars(inputStr, &iscopy);
	//printf("befor\n%s\n", model);
	
	const char* res = marFunction2(model, input);
	jstring rtrn = env->NewStringUTF(res);
//	(*env)->ReleaseStringChars(env, trainStr, trn);
    env->ReleaseStringUTFChars(modelStr, model);
	env->ReleaseStringUTFChars(inputStr, input);
	return (rtrn);
}