import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;


public class CommandParse {
	
	Map<String, String> cmdline;
	Map<String, Integer> required;
	Map<String, String> keys;
	String usage;
	String reqArg;
	
	public void initialize(HashMap<String, String> args, ArrayList<String> req, String use)
	{
		usage = use;
		this.initialize(args, req);
	}
	
	public void initialize(HashMap<String, String> args, ArrayList<String> req)
	{
		// load what is required
		required = new HashMap<String, Integer>();
		Iterator<String> it = req.iterator();
		while(it.hasNext())
			required.put(it.next(), 1);
		
		cmdline = new HashMap<String, String>(args.size());

		keys = args;
		
		// generate the usage here.
		StringBuilder tmp = new StringBuilder();
		tmp.append("\n\tError:  The Arguments ");
		String sb = "";
		String se = "";
		Iterator<String> it2 = args.keySet().iterator();
		while(it2.hasNext())
		{
			String key = it2.next();
			if(required.containsKey(key))
			{
				sb = " ";
				se = " ";
				tmp.append(sb + key + " " + args.get(key) + se);
			}
//			else
//			{
//				sb = " {";
//				se = "} ";
//			}
			
			
		}
		tmp.append(" are required.\n");
		reqArg = tmp.toString();
		
	}
	
	public void fill(String [] arg)
	{
		int sum = 0;
		for(int i = 0; i < arg.length; i++)
		{
			if(required.get(arg[i]) != null) sum++;
			
			if(keys.containsKey(arg[i])) cmdline.put(arg[i], arg[++i]);
			else System.err.println("unknow argument " + arg[i++]);
		}
		
		if(sum != required.size())
			{
				System.err.println(reqArg);
				System.err.print(usage);
				
				System.exit(-1);
			}
			
	}
	
	public String get(String arg)
	{
		return cmdline.get(arg);
	}
	

}
